#[doc = "Register `F12` reader"]
pub struct R(crate::R<F12_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<F12_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<F12_SPEC>> for R {
    fn from(reader: crate::R<F12_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `F12` writer"]
pub struct W(crate::W<F12_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<F12_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<F12_SPEC>> for W {
    fn from(writer: crate::W<F12_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `F1` reader - Fifo 1"]
pub struct F1_R(crate::FieldReader<u8, u8>);
impl F1_R {
    pub(crate) fn new(bits: u8) -> Self {
        F1_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for F1_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `F1` writer - Fifo 1"]
pub struct F1_W<'a> {
    w: &'a mut W,
}
impl<'a> F1_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0xff) | (value as u8 & 0xff);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:7 - Fifo 1"]
    #[inline(always)]
    pub fn f1(&self) -> F1_R {
        F1_R::new((self.bits & 0xff) as u8)
    }
}
impl W {
    #[doc = "Bits 0:7 - Fifo 1"]
    #[inline(always)]
    pub fn f1(&mut self) -> F1_W {
        F1_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "FIFO 1\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [f12](index.html) module"]
pub struct F12_SPEC;
impl crate::RegisterSpec for F12_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [f12::R](R) reader structure"]
impl crate::Readable for F12_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [f12::W](W) writer structure"]
impl crate::Writable for F12_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets F12 to value 0"]
impl crate::Resettable for F12_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
